diff --git a/libglusterfs/src/glusterfs/glusterfs.h b/libglusterfs/src/glusterfs/glusterfs.h
index 834cd2f531a..a0e73c2dc94 100644
--- a/libglusterfs/src/glusterfs/glusterfs.h
+++ b/libglusterfs/src/glusterfs/glusterfs.h
@@ -315,7 +315,7 @@ enum gf_internal_fop_indicator {
 #define DHT_SKIP_OPEN_FD_UNLINK "dont-unlink-for-open-fd"
 #define DHT_IATT_IN_XDATA_KEY "dht-get-iatt-in-xattr"
 #define DHT_MODE_IN_XDATA_KEY "dht-get-mode-in-xattr"
-#define GF_MKNOD_REPLACE_KEY "mknod-replace-if-linkto"
+#define GF_MKNOD_REPLACE_KEY "force-replace"
 #define GET_LINK_COUNT "get-link-count"
 #define GF_GET_SIZE "get-size"
 #define GF_PRESTAT "virt-gf-prestat"
diff --git a/xlators/cluster/dht/src/dht-rename.c b/xlators/cluster/dht/src/dht-rename.c
index fdb7171c41f..b9aac868209 100644
--- a/xlators/cluster/dht/src/dht-rename.c
+++ b/xlators/cluster/dht/src/dht-rename.c
@@ -1404,7 +1404,9 @@ dht_rename_create_links(call_frame_t *frame)
                    "Failed to set dictionary value: key = %s,"
                    " path = %s",
                    GF_MKNOD_REPLACE_KEY, local->loc.path);
-            ret = 0;
+            dict_unref(xattr_new);
+            ret = -1;
+            goto cleanup;
         }
 
         local->params = xattr_new;
